    page    60, 132

;******************************************************************************
        title   MSJDrvr - MSJ test VxD
;******************************************************************************
;
;   1998 James M. Finnegan - Microsoft Systems Journal
;
;******************************************************************************

    .386p

    .XLIST
    INCLUDE VMM.Inc
    INCLUDE Debug.Inc
    .LIST

MSJDrvr_Major_Ver      equ     01h
MSJDrvr_Minor_Ver      equ     00h
MSJDrvr_Device_ID      equ     Undefined_Device_ID

;==============================================================================
;           V I R T U A L   D E V I C E   D E C L A R A T I O N
;==============================================================================

Declare_Virtual_Device  MSJDRVR, MSJDrvr_Major_Ver, MSJDrvr_Minor_Ver,\
                        MSJDrvr_Control_Proc, MSJDrvr_Device_ID,\
			Undefined_Init_Order,,

;==============================================================================
;                  N O N - P A G E A B L E   D A T A
;==============================================================================

VxD_LOCKED_DATA_SEG

VxD_LOCKED_DATA_ENDS

VxD_LOCKED_CODE_SEG

;==============================================================================
;                      N O N P A G E A B L E   C O D E
;==============================================================================

;------------------------------------------------------------------------------
;
;   MSJDrvr_Control_Proc
;
;   DESCRIPTION:
;       Dispatches VMM control messages to the appropriate handlers.
;
;------------------------------------------------------------------------------

BeginProc MSJDrvr_Control_Proc

    ; Dynamic load messages
    Control_Dispatch Sys_Dynamic_Device_Init, MSJDrvr_DynaDevice_Init
    Control_Dispatch Sys_Dynamic_Device_Exit, MSJDrvr_DynaDevice_Exit

    ; DeviceIOControl messages - send 'em to our C module...
    Control_Dispatch W32_DEVICEIOCONTROL,     CVXD_W32_DeviceIOControl, sCall, <ecx, ebx, edx, esi>

    clc
    ret

EndProc MSJDrvr_Control_Proc



;------------------------------------------------------------------------------
;
;   MSJDrvr_DynaDevice_Init
;
;   DESCRIPTION:
;       Dynamic VxD initialization procedure.
;
;------------------------------------------------------------------------------

BeginProc MSJDrvr_DynaDevice_Init

	clc
	ret

EndProc MSJDrvr_DynaDevice_Init


;------------------------------------------------------------------------------
;
;   MSJDrvr_DynaDevice_Exit
;
;   DESCRIPTION:
;       Dynamic VxD unload procedure.
;
;------------------------------------------------------------------------------

BeginProc MSJDrvr_DynaDevice_Exit

	clc
	ret

EndProc MSJDrvr_DynaDevice_Exit


VxD_LOCKED_CODE_ENDS

END

